#include "Timer.h"
#include <iostream>

//-----------------------------------------------------------------------------------------------------------------------------
Timer::Timer()
{
  m_StartTimePoint = std::chrono::high_resolution_clock::now();
}

//-----------------------------------------------------------------------------------------------------------------------------
Timer::~Timer()
{
  auto endTimePoint = std::chrono::high_resolution_clock::now();

  auto start = std::chrono::time_point_cast<std::chrono::microseconds>(m_StartTimePoint).time_since_epoch().count();
  auto end   = std::chrono::time_point_cast<std::chrono::microseconds>(endTimePoint).time_since_epoch().count();

  auto duration = end - start;
  printf("Duration in Microseconds: %2d (%.3f ms)\n", duration, (duration * 0.001));
  //std::cout << "Duration in Microseconds: " << duration << " (" << duration * 0.001 << " ms)" << std::endl;
}